-- Licensed Materials - Property of IBM
-- 5724-M24
-- Copyright IBM Corporation 2011. All Rights Reserved.
-- US Government Users Restricted Rights- Use, duplication or disclosure
-- restricted by GSA ADP Schedule Contract with IBM Corp.
-- ------------------------------------------------------------------------------------
--
-- Scriptfile to upgrade database from v7.5 to v8.0 for Oracle
--
---------------------------------------------------------------------------------------
-- Following variables need to be changed for customization before running this script: 
-- @SCHEMA@ = the schema owner, eg MONITOR
--
-- Run the script in SQL*Plus.
--
-- USAGE:  sqlplus system/passw0rd@orcl @upgradeSchema750.sql
--
-- ------------------------------------------------------------------------------------

---------------------------------------------------------CHANGED:  SCHEMA_VERSION
DELETE FROM @SCHEMA@.SCHEMA_VERSION;
INSERT INTO @SCHEMA@.SCHEMA_VERSION (
        SCHEMA_VERSION, DATA_MIGRATION) 
        VALUES( 80, 0 );
        


--Changes for 8.0

ALTER TABLE @SCHEMA@.ACT_MGR_ALERTS_T 
        ADD (PRIORITY NUMBER(20,0));

CREATE TABLE @SCHEMA@.ACT_ALERT_COMMENTS_T
(
  ALERT_ID                           VARCHAR2(32)        NOT NULL ,
  COMMENT_OWNER                      VARCHAR2(32)        NOT NULL ,
  COMMENT_TIME                       TIMESTAMP           NOT NULL ,
  COMMENT_TEXT                       VARCHAR2(4000)               ,
  VERSION_ID                         NUMBER(5,0)         NOT NULL 
) TABLESPACE MONDSTS
  LOGGING;

ALTER TABLE @SCHEMA@.ACT_ALERT_COMMENTS_T ADD
(
  PRIMARY KEY ( ALERT_ID, COMMENT_OWNER, COMMENT_TIME )
  USING INDEX TABLESPACE MONIDXTS
);


ALTER TABLE @SCHEMA@.ACT_MGR_ALERTS_T 
        ADD (STATUS VARCHAR2(32));


ALTER TABLE @SCHEMA@.META_MONITOR_CONTEXT_T 
        ADD (HIDDEN NUMBER(5,0));        

UPDATE @SCHEMA@.META_MONITOR_CONTEXT_T SET HIDDEN = 0;

ALTER TABLE  @SCHEMA@.META_MONITOR_CONTEXT_T 
MODIFY	     HIDDEN
CONSTRAINT   META_MONITOR_CONTEXT_C1  NOT NULL;


ALTER TABLE @SCHEMA@.META_MONITOR_METRIC_T 
        ADD (HIDDEN NUMBER(5,0));        

UPDATE @SCHEMA@.META_MONITOR_METRIC_T SET HIDDEN = 0;

ALTER TABLE  @SCHEMA@.META_MONITOR_METRIC_T 
MODIFY	     HIDDEN
CONSTRAINT   META_MONITOR_METRIC_C1  NOT NULL;


ALTER TABLE @SCHEMA@.META_KPI_T
        ADD (HIDDEN NUMBER(5,0));        

UPDATE @SCHEMA@.META_KPI_T SET HIDDEN = 0;

ALTER TABLE  @SCHEMA@.META_KPI_T 
MODIFY	     HIDDEN
CONSTRAINT   META_KPI_C1  NOT NULL;        

COMMIT;
QUIT  