#!/bin/sh -v

#############################################################################
#  Licensed Materials - Property of IBM
#  5724-M24
#  Copyright IBM Corporation 2007,2008. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
#############################################################################

#######################################################
#                                                     #
# Subroutine: Usage                                   #
#                                                     #
#######################################################

usage () {
  echo ""
  echo "showcase.sh -w <profile directory> "
  echo ""
  echo "where:  "
  echo ""
  echo "  -w <profile directory> :"
  echo "     WAS profile directory. If not provided will assume ../.. "
  echo ""
  exit
  
}

#######################################################
#                                                     #
# Read command line options                           #
#                                                     #
#######################################################

while getopts "w:u:p:" opt
do
  case $opt in
    w) profileDir=$OPTARG;;
    ?) usage
  esac
done

. $profileDir/bin/setupCmdLine.sh 

cp ${WAS_HOME}/scripts.wbm/AAMExport/config.properties ${WAS_HOME}/scripts.wbm/AAMExport/installed_config.properties > /dev/null 2>&1

cp ${profileDir}/config.wbm/alertTemplate.properties ${WAS_HOME}/scripts.wbm/AAMExport/config.properties > /dev/null 2>&1
cp ../artifacts/ShowcaseAlert.xml ${WAS_HOME}/scripts.wbm/AAMExport/ShowcaseAlert.xml > /dev/null 2>&1

cd ${WAS_HOME}/scripts.wbm/AAMExport > /dev/null 2>&1
./runAAMExport.sh > /dev/null 2>&1
cp ${WAS_HOME}/scripts.wbm/AAMExport/installed_config.properties ${WAS_HOME}/scripts.wbm/AAMExport/config.properties > /dev/null 2>&1
rm -f ${WAS_HOME}/scripts.wbm/AAMExport/installed_config.properties > /dev/null 2>&1
rm -f ${WAS_HOME}/scripts.wbm/AAMExport/ShowcaseAlert.xml > /dev/null 2>&1

