#  Licensed Materials - Property of IBM
#  5724-M24
#  Copyright IBM Corporation 2007, 2008. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
#

import java 

def wsadminToList(inStr):
        outList=[]
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
                tmpList = inStr[1:-1].split(" ")
        else:
                tmpList = inStr.split("\n")  #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();        #removes any Windows "\r"
                if (len(item)>0):
                        outList.append(item)
        return outList
#endDef

def isAppExist(apps, appName):
    # Check if App is already installed on the target server
    # Comparing the application name.
    appExist = "False"
    for tmpAppName in wsadminToList(apps):
        if (cmp(tmpAppName, appName) == 0):
            appExist = "True"
            break 
        #endIf 
    #endFor
    return appExist
#enddef

if ((len(sys.argv) != 1)):
        print "This script requires 1 parameter: profilePath"
        print "e.g.: <scriptname>.py /opt/WebSphere/Monitor/profiles/MonSrv01"
	raise ValueError	

profilePath = sys.argv[0]
print "profilePath="+profilePath
execfile(profilePath+'/config.wbm/MonitorProfileVals.py')

if (ndType == "managed"):
    try:
        cellName = AdminControl.getCell()
    except:
        print "warning: AdminControl may not be available."    

#install EAR
execfile(moncommonPath+'/installEar.py')

installableApps = washome+"/installableApps.wbm"
print "installableApps ="+installableApps


#---------------------------------------------------------
# First, list the existing applications 
#---------------------------------------------------------
apps = AdminApp.list( )
print "INFO:  Installed applications: "
print str(apps)

rc = 0
#Install Action Manager
try:
    location = installableApps
    ear = aamEarName
    app = aamAppname
    cell     = cellName
    node     = nodeName

    if(isAppExist(apps,app) == "False"):
        properties = ['-appname',app,'-cell',cellName,'-node',nodeName,'-server',serverName]
        AdminApp.install(location+"/"+ear+".ear",properties)
        AdminConfig.save()
    else:
        print app +" application already deployed to the cell." 
except:
    print "warning: Install Action Manager failed."
    rc = -1    

#Install DMS
try:
    location = installableApps
    ear = dmsServiceEarName
    app = dmsServiceAppname
    cell     = cellName
    node     = nodeName
    
    if(isAppExist(apps,app) == "False"):
        properties = ['-appname',app,'-cell',cellName,'-node',nodeName,'-server',serverName]
        AdminApp.install(location+"/"+ear+".ear",properties)
        AdminConfig.save()
    else:
        print app +" application already deployed to the cell." 
        
except:
    print "warning: Install DMS failed."
    rc = -1    

#Install Mobile WEB Dashboard
try:
    location = installableApps
    ear = webMobileDashboardEarName
    app = webMobileDashboardAppname
    cell     = cellName
    node     = nodeName
    
    if(isAppExist(apps,app) == "False"):
        properties = ['-appname',app,'-cell',cellName,'-node',nodeName,'-server',serverName]
        AdminApp.install(location+"/"+ear+".ear",properties)
        AdminConfig.save()
    else:
        print app +" application already deployed to the cell." 
        
except:
    print "warning: Install Mobile WEB Dashboard failed."
    rc = -1    

#Install REST Service
try:
    location = installableApps
    ear = restServicesEarName
    app = restServicesAppname
    cell     = cellName
    node     = nodeName
    warName = restServicesWarName

    if(isAppExist(apps,app) == "False"):
        mapWebModOptStr='-MapWebModToVH [[ "'+warName+'.war" '+warName+'.war,WEB-INF/web.xml default_host ]]'
        properties = ['-appname',app,'-cell',cellName,'-node',nodeName,'-server',serverName,mapWebModOptStr]
        AdminApp.install(location+"/"+ear+".ear",properties)
        AdminConfig.save()
    else:
        print app +" application already deployed to the cell." 
        
except:
    print "warning: Install REST Service failed." 
    rc = -1

#Install BSpace
try:
    optList = "-nodeName "+nodeName+" -serverName "+serverName
    print "optList="+optList
    AdminTask.installBusinessSpace(optList)
    AdminConfig.save()
except:
    print "warning: Install BSpace failed." 
    rc = -1

#Configure BSpace
try:
    optList = "-nodeName "+nodeName+" -serverName "+serverName+" -productTypeForDatasource WBM"
    print "optList="+optList
    AdminTask.configureBusinessSpace(optList)
    AdminConfig.save()
except:
    print "warning: Configure BSpace failed." 
    rc = -1
    
if(rc == -1):
    raise ValueError("Install WBM Applications failed")

        