#  Licensed Materials - Property of IBM
#  5724-M24
#  Copyright IBM Corporation 2009, 2010. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
#

import java 

if ((len(sys.argv) != 1)):
        print "This script requires 1 parameter: profilePath"
        print "e.g.: <scriptname>.py /opt/WebSphere/Monitor/profiles/MonSrv01"
	raise ValueError	

profilePath = sys.argv[0]
print "profilePath="+profilePath
execfile(profilePath+'/config.wbm/MonitorProfileVals.py')
execfile(moncommonPath+'/MonitorServerUtil.py')
	
UtilWsadminHolder.AdminConfig = AdminConfig
UtilWsadminHolder.AdminTask = AdminTask

cellName = AdminConfig.showAttribute(AdminConfig.list("Cell"), "name")

#Add custom property for webSphereDefaultIsolationLevel:2 (Cursor Stability (CS))
datasourceProps = {"webSphereDefaultIsolationLevel":"2"}
if(wbmDBType == S_COMMON_DB_DERBY_EMBEDDED):
    datasourceProps["databaseName"] = databaseName
if(wbmDBType == S_COMMON_DB_DB2 or wbmDBType.startswith(S_COMMON_DB_DB2_ZOS)):
    datasourceProps["databaseName"] = databaseName
    datasourceProps["driverType"] = datasourceDriverType
    datasourceProps["serverName"] = datasourceServerName
    datasourceProps["portNumber"] = datasourcePortNumber
if(wbmDBType == S_COMMON_DB_MS_SQLSERVER):
    datasourceProps["databaseName"] = databaseName
    datasourceProps["serverName"] = datasourceServerName
    datasourceProps["portNumber"] = datasourcePortNumber
if (wbmDBType == S_COMMON_DB_ORACLE_11g):
    #type 2 = OCI, type 4 = thin.  
    if(datasourceDriverType == "2"):
        datasourceProps["URL"] = "jdbc:oracle:oci:@"+datasourceServerName+":"+datasourcePortNumber+":"+databaseName
    else:
        datasourceProps["URL"] = "jdbc:oracle:thin:@"+datasourceServerName+":"+datasourcePortNumber+":"+databaseName

scope = Scope(clusterName, cellName, nodeName, serverName)

# Setup objects for JDBC Provider.
jdbcProviderInfo = JdbcProviderInfo(jdbcProviderName, jdbcProviderDesc, jdbcProviderImplClass, jdbcProviderClassPath)
# Setup objects for Business Space datasource.
bspaceDatasourceInfo = DatasourceInfo(bspaceDatasourceName, bspaceDatasourceDesc, bspaceDatasourceJndi, datasourceHelperClassname, datasourceMaxConnections, datasourceProps, jdbcProviderName, datasourceAuthAliasName)

# Creates the JDBC Provider.
createJdbcProvider(scope, Scope.SERVER_SCOPE, jdbcProviderInfo)
# Create monitor datasource for Business Space datasource
createDatasource(scope, Scope.SERVER_SCOPE, bspaceDatasourceInfo)
AdminConfig.save()
    
