#************************************************************************
# Licensed Materials - Property of IBM
# 5724-M24
# Copyright IBM Corporation 2011. All Rights Reserved.
# US Government Users Restricted Rights - Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
#************************************************************************


from java.lang import Boolean
from java.lang import Integer
from java.lang import String
from java.lang import System

from com.ibm.wbimonitor.lifecycle.spi.mbeans import RESTSecurityAdminMBeanFactory

if ((len(sys.argv) != 3)):
    print "This script requires 3 parameters: userId, resourceGroup(root, etc) and role(KPI-Administrator, etc)"
    print "e.g.: <scriptname>.py wbmonitor"
    raise ValueError    

userId = sys.argv[0]
resourceGroup = sys.argv[1]
role = sys.argv[2]

AdminControl.trace( 'com.ibm.wbimonitor.*=all=enabled' )

rest_mbean = RESTSecurityAdminMBeanFactory.getMBean( AdminControl.getAdminClient() )
print 'RESTSecurityAdminMBean.toString=' + rest_mbean.toString()

#The following assigns 'SuperUser' role to the user someUser. Fully qualified DN is required.
#The return type is a boolean 'true' or 'false'
fullUserId = AdminTask.searchUsers ('[-uid '+ userId + ']')
result = rest_mbean.assignRoleToUserOnResourceGroup(fullUserId,resourceGroup,role,"user")
print result
AdminConfig.save()


