#  Licensed Materials - Property of IBM
#  5724-M24
#  Copyright IBM Corporation 2007, 2009. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
#

import java

if ((len(sys.argv) != 1)):
        print "This script requires 1 parameter: profilePath"
        print "e.g.: <scriptname>.py /opt/WebSphere/Monitor/profiles/MonSrv01"
	raise ValueError	

profilePath = sys.argv[0]
print "profilePath="+profilePath
execfile(profilePath+'/config.wbm/MonitorProfileVals.py')

location = washome+"/installableApps.wbm"
ear = aamEarName
app = aamAppname
cell     = cellName
node     = nodeName
server   = serverName

print "location: "+location+" app: "+app+" cell: "+cell+" node: "+node+"server: "+server

execfile(moncommonPath+'/MonitorServerUtil.py')
UtilWsadminHolder.AdminConfig = AdminConfig
UtilWsadminHolder.AdminTask = AdminTask

scope = Scope(clusterName, cell, node, server)
print "scope="+str(scope)

rc = 0
#create a queue destination on Monitor Bus
busName = "MONITOR." + cell + ".Bus"

#create SIB JMS
print "create SIB JMS resource"
cellConfigId = scope.getConfigId(Scope.CELL_SCOPE)

#Queue Connection Factory
optList = "-name \""+aamQConnFactoryName+"\" -jndiName "+aamQConnFactoryJndi+" -busName "+busName+" -type Queue -containerAuthAlias "+busAliasName+" -authDataAlias "+busAliasName
print "creating queue connection factory optList="+optList
try:
    AdminTask.createSIBJMSConnectionFactory(cellConfigId,optList)
    AdminConfig.save()
except:
    print "warning: failed to createSIBJMSConnectionFactory. The queue connection factory may already be created."	
    rc = -1
print "done creating queue connection factory"

#Queue
optList = "-name \""+aamQName+"\" -jndiName "+aamQJndi+" -busName "+busName+" -queueName "+aamQDestName
print "creating queue optList="+optList
try:
    AdminTask.createSIBJMSQueue(cellConfigId,optList)
    AdminConfig.save()
except:
    print "warning: failed to createSIBJMSQueue. The queued may already be created."
    rc = -1
print "done creating queue"

#ActivationSpec
optList = "-name \""+aamActivationSpecName+"\" -jndiName "+aamActivationSpecJndi+" -busName "+busName+" -destinationJndiName "+aamQJndi+" -authenticationAlias "+busAliasName+" -maxBatchSize 10"+" -maxConcurrency 10"
print "creating activation specification optList="+optList
try:
    AdminTask.createSIBJMSActivationSpec(cellConfigId,optList)
    AdminConfig.save()
except:
    print "warning: failed to createSIBJMSActivationSpec. The activation specification may already be created."	
    rc = -1
print "done creating activation specification"

#Create Event Group
print "Creating EventProfile"  
try:
    # Get EventProfile Group id
    optList = "/EventInfrastructureProvider:EventInfrastructureProvider/EventGroupProfileList:Event groups list/"
    print "optList="+ str(optList)
    egpl = AdminConfig.getid(optList)
    print "egpl="+str(egpl)

    if(egpl != None and egpl != ""):
        # Create the EventGroupProfile
        eventSelectorString = "CommonBaseEvent[extendedDataElements/@name = 'BusinessSituationName']"
        optList = [["eventGroupName",aamEventGroupName], ["eventSelectorString",aamEventSelectorString]]
        print "optList="+str(optList)
        epg = AdminConfig.create("EventGroupProfile",egpl,optList)
        print "epg="+str(epg)
        
        # Create the DistributionQueue
        optList = [["queueConnectionFactoryJNDIName",aamQConnFactoryJndi], ["queueJNDIName",aamQJndi]]
        print "optList=" + str(optList)
        dq = AdminConfig.create("DistributionQueue",epg,optList)
        print "dq="+str(dq)
        AdminConfig.save()
    else:
        print aamEventGroupName +"is not created because CEI is not enabled."
except:
    print "warning: failed to create EventProfile."
    rc = -1
print "done Creating EventProfile"
    
if (ndType != "dmgr"):
    #install EAR
    execfile(moncommonPath+'/installEar.py')
    rc2 = installEar(location, ear, app, node, server)
    if(rc2 == -1):
        rc = -1
            
if(rc == -1):
    raise ValueError("Install and/or configure ActionServices failed")
