#  Licensed Materials - Property of IBM
#  5724-M24
#  Copyright IBM Corporation 2009, 2010. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.

import java 

if ((len(sys.argv) != 1)):
    print "This script requires 1 parameter: profilePath"
    print "e.g.: <scriptname>.py /opt/WebSphere/Monitor/profiles/MonSrv01"
    raise ValueError    

profilePath = sys.argv[0]
print "profilePath="+profilePath
execfile(profilePath+'/config.wbm/MonitorProfileVals.py')


optList = ['-server',nodeName,serverName]
if (msFileStore == "true"):
    if (meLogDirectory != ""):
        optList.append("-filestoreLogDirectory")
        optList.append(meLogDirectory)
    if (mePermanentStoreDirectory != ""):
        optList.append("-filestorePermanentStoreDirectory")
        optList.append(mePermanentStoreDirectory)
    if (meTemporaryStoreDirectory != ""):
        optList.append("-filestoreTemporaryStoreDirectory")
        optList.append(meTemporaryStoreDirectory)
elif(msDataStore == "true"):
    lJnidiName = meDatasourceJndi;
    lSchemaName = dataStoreDefaultWBMSchemaName
    lAuthAlias = datasourceAuthAliasName
    lCreateTable = "true"
    if (dataStoreExistingDataSource == "true"):
        lJnidiName = dataStoreJndiName
        lSchemaName = dataStoreSchemaName
        if(dataStoreAuthAlias != "(none)" and dataStoreAuthAlias != "${dataStoreAuthAlias}"):
            lAuthAlias = dataStoreAuthAlias
        lCreateTable = dataStoreCreateTables
                
    if(dataStoreExistingDataSource != "true" and wbmDBType == S_COMMON_DB_DERBY_EMBEDDED):
        optList.append("-createDefaultDatasource")
        optList.append("true")
    else:
        optList.append("-createDefaultDatasource")
        optList.append("false")
        optList.append("-datasourceJndiName")
        optList.append(lJnidiName)
        optList.append("-schemaName")
        optList.append(lSchemaName)

        optList.append("-datasourceAuthAlias")
        i= lAuthAlias.find('/')
        lAuthAliasName=lAuthAlias[i+1:len(lAuthAlias)]
        optList.append(lAuthAliasName)

        optList.append("-createTables")
        #The ME cannot create tables on zOS. The user has to run ddl manually.
        if(wbmDBType == S_COMMON_DB_DB2_ZOS or wbmDBType.startswith(S_COMMON_DB_DB2_ZOS)):
            lCreateTable = "false"
        optList.append(lCreateTable)
    
print "optList="+str(optList)

sys.argv = optList
execfile(moncommonPath+'/../sib/monitorSIBConfig.py')
