@REM ***************************************************************
@REM Licensed Material - Property of IBM
@REM 
@REM 5724-M24
@REM 
@REM Copyright IBM Corp. 2009.  All rights reserved.
@REM 
@REM US Government Users Restricted Rights - Use, duplication or
@REM disclosure restricted by GSA ADP Schedule Contract with IBM
@REM Corp.
@REM ***************************************************************
@echo off

setlocal

@REM echo.
@REM echo Start Web Dashboard Migration Script
@REM echo.

GOTO Loop
@REM #######################################################
@REM #                                                     #
@REM # IVT Usage                                           #
@REM #                                                     #
@REM #######################################################
:USAGE
  echo.
  echo  upgradePages -host ^<host name^> -port ^<SOAP port^>
  echo                    -user ^<monitor server user id^> -password  ^<monitor server password^>
  echo.
  echo  where:  
  echo.
  echo   -host ^<host name^>:
  echo       The host name of monitor profile you connect to
  echo.
  echo   -port ^<SOAP port^>:
  echo       The SOAP port of monitor profile you connect to
  echo.
  echo   -user ^<monitor server user id^>:
  echo       User id of monitor profile
  echo.
  echo   -password  ^<monitor server password^>:
  echo      Password of monitor profile
  echo.    
  GOTO DONE  
  
  
@REM #######################################################
@REM #                                                     #
@REM # Read command line options                           #
@REM #                                                     #
@REM #######################################################
:Loop
IF "%1" == "" GOTO Continue
IF "%1" == "-host" (
  set hostname=%2
  GOTO Forward
)
IF "%1" == "-port" (
  set portNumber=%2
  GOTO Forward
)
IF "%1" == "-user" (
  set userID=%2
  GOTO Forward
)
IF "%1" == "-password" (
  set password=%2
  GOTO Forward
)

echo ERROR: Invalid parameter: %1
GOTO USAGE

:Forward
shift /1
shift /1
GOTO Loop
:Continue

@REM #######################################################
@REM #                                                     #
@REM # Validate parameters                                 #
@REM #                                                     #
@REM #######################################################

IF %hostname%. == . (
  echo ERROR: Missing or invalid parameter: host
  GOTO DONE
)
@REM echo hostname=%hostname%

IF %portNumber%. == . (
  echo ERROR: Missing or invalid parameter: port
  GOTO DONE
)
@REM echo portNumber=%portNumber%

IF %userID%. == . (
  echo ERROR: Missing or invalid parameter: user
  GOTO DONE
)
@REM echo userID=%userID%

IF %password%. == . (
  echo ERROR: Missing or invalid parameter: password
  GOTO DONE
)
@REM echo password=%password%

set CUR_DIR=%cd%
cd /d "%~dp0\..\..\.."
set WAS_HOME=%cd%
cd /d "%CUR_DIR%"
call "%WAS_HOME%\bin\setupCmdLine.bat"

set LOG_DIR=%WAS_HOME%\logs\wbm\webdashboardmigration
if not exist "%LOG_DIR%" mkdir "%LOG_DIR%"
set LOG_FILE=%LOG_DIR%\monitor_webdashboard_migration_log.txt

echo.
@REM echo call upgradePages.jy
echo Starting migration, please check log file %LOG_FILE% to make sure migration was successful without any exception after it's completed. Then you can verify migration of Web dashboard on the admin console of Business Space.

"%WAS_HOME%\bin\wsadmin" -connType SOAP -host %hostname% -port %portNumber% -user %userID% -password %password% -lang jython -f upgradePages.jy > "%LOG_FILE%" 2>&1

:DONE
@REM echo "Done"
endlocal
@echo on