<%-- 
  Licensed Materials - Property of IBM
  5724-M24
  Copyright IBM Corporation 2009,2010.
  All Rights Reserved.
US Government Users Restricted Rights- Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp. 
--%>

<%@page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" session="false"%>

<%@taglib uri="http://java.sun.com/portlet" prefix="portlet"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib tagdir="/WEB-INF/tags" prefix="wbm"%>

<%-- define portlet JSP vars --%>
<portlet:defineObjects />

<%-- set the locale to match what the portlet thinks is the locale --%>
<fmt:setLocale value="${renderRequest.locale}"/>

<%-- import help support javascript library --%>
<c:url var="helpJavaScriptURL" context="${renderRequest.contextPath}" value="/scripts/help.js"/>
<script language="JavaScript" src="${helpJavaScriptURL}"></script>

<%-- set the resource bundle name and key prefix to use between within the fmt:bundle element --%>
<fmt:bundle basename="com.ibm.wbimonitor.admin.topology.nl.PortletResource" prefix="ABX.CONFIG.">

<%-- attach the monitor specifc stylesheet --%>
<c:url var="monitorStyleSheetURL" context="${renderRequest.contextPath}" value="/theme/monitor-styles.css"/>
<link rel="stylesheet" href="${monitorStyleSheetURL}" type="text/css" />

<script type="text/javascript">
function ${ns}func_1(evt) {
	evt = (evt) ? evt : ((window.event) ? window.event : null);
	var targetElement = (evt.target) ? (evt.target) : ((evt.srcElement) ? evt.srcElement : null);
	if(targetElement.nodeType == 3) targetElement = targetElement.parentNode;
	if(targetElement.id == "securityEnable") {
		document.getElementById("monUid").disabled = false;
		document.getElementById("monPwd").disabled = false;
		document.getElementById("abxUid").disabled = false;
		document.getElementById("abxPwd").disabled = false;
	} else {
		document.getElementById("monUid").disabled = true;
		document.getElementById("monPwd").disabled = true;
		document.getElementById("abxUid").disabled = true;
		document.getElementById("abxPwd").disabled = true;
		
	}
}

</script>

<div class="monitor">

<%-- display info/warning/error messages --%>
<wbm:msgbox messages="${messages}"/>

<c:set var="topologyStatusURL"><portlet:actionURL><portlet:param name="action" value="forward"/><portlet:param name="pageName" value="topology-status"/></portlet:actionURL></c:set>
<p class="breadcrumb-trail">
<a href="${topologyStatusURL}"><fmt:bundle basename="com.ibm.wbimonitor.admin.topology.nl.PortletResource" prefix="MON.CONFIG."><fmt:message key="PAGE.BREADCRUMB"/></fmt:bundle></a> &gt; 
<fmt:message key="PAGE.BREADCRUMB"/></p>
<p><fmt:message key="PAGE.INSTRUCTION"/></p>

<%-- compute rest api service status display --%>
<c:choose>
	<c:when test="${alphabloxStatus.deployed}">
		<c:choose>
			<c:when test="${empty alphabloxStatus.location.cluster}">
				<c:set var="alphabloxStatusValue">
					<fmt:message key="FIELD.STATUS.DEPLOYED.SERVER">
						<fmt:param value="${alphabloxStatus.location.server}"/>
						<fmt:param value="${alphabloxStatus.location.node}"/>
					</fmt:message>
				</c:set>
			</c:when>
			<c:otherwise>
				<c:set var="alphabloxStatusValue">
					<fmt:message key="FIELD.STATUS.DEPLOYED.CLUSTER">
						<fmt:param value="${alphabloxStatus.location.cluster}"/>
					</fmt:message>
				</c:set>
			</c:otherwise>
		</c:choose>
	</c:when>
	<c:otherwise>
		<c:set var="alphabloxStatusValue"><fmt:message key="FIELD.STATUS.NOT.DEPLOYED"/></c:set>
	</c:otherwise>
</c:choose>

<div class="mainContent">

<div class="sectionContent">
<p class="config-section-title"><fmt:message key="MAIN.SECTION.TITLE"/></p>
<table>
	<tr>
		<td><label class="hasHelp" onclick="updateHelpPortlet(event);" title="<fmt:message key='FIELD.STATUS.TOOLTIP'/>"><fmt:message key="FIELD.STATUS.LABEL"/></label></td>
	</tr>
	<tr>
		<td><textarea rows="2"  name="statusDisplay" title="${alphabloxStatusValue}" readonly="readonly" class="a11y-read-only">${alphabloxStatusValue}</textarea></td>
	</tr>
</table>
<c:if test="${not alphabloxStatus.deployed}">
<p><fmt:message key="FIELDSET.LABEL"/></p>

<c:set var="deployAlphabloxActionURL"><portlet:actionURL><portlet:param name="action" value="deployAlphablox"/></portlet:actionURL></c:set>
<form action="${deployAlphabloxActionURL}" method="post">
	<fieldset><legend><fmt:message key="FIELDSET.SECURITY.LEGEND"/></legend>
	<table cellpadding="3">
		<tr valign="top">
			<td><label for="targetServer" class="hasHelp" onclick="updateHelpPortlet(event);" title="<fmt:message key='SECURITY.FIELD.TARGET.TOOLTIP'/>"><fmt:message key="SECURITY.FIELD.TARGET.LABEL"/></label></td>
		</tr>
		<tr valign="top">
			<td>
				<table cellpadding="3">
					<tr valign="top">
						<td><input id="securityEnable" disabled type="radio" name="security" value="yes" onclick="${ns}func_1(event)" ${security eq 'yes' ? 'checked="checked"' : ''} title="<fmt:message key='SELECT.TARGET.SECURITY.TOOLTIP'/>"></td>
						<td><label for="securityEnable" title="<fmt:message key='SELECT.TARGET.SECURITY.TOOLTIP'/>" onclick="updateHelpPortlet(event);"><fmt:message key="RADIO.SECURITYENABLED.LABEL"/></label></td>
						<td><input id="securityDisable" disabled type="radio" name="security" value="no" onclick="${ns}func_1(event)" ${security eq 'no' ? 'checked="checked"' : ''} title="<fmt:message key='SELECT.TARGET.SECURITY.TOOLTIP'/>"></td>
						<td><label for="securityDisable" title="<fmt:message key='SELECT.TARGET.SECURITY.TOOLTIP'/>" onclick="updateHelpPortlet(event);"><fmt:message key="RADIO.SECURITYDISABLED.LABEL"/></label></td>
					</tr>
				</table>
			</td>
		</tr>
		<tr valign="top">
			<td>
				<table width="100%" cellpadding="3">
					<tr valign="top">
						<fmt:message key="FIELD.MONUSERID.TOOLTIP" var="monuidTooltip"/>
						<td class="table-text"  scope="row" valign="top">
							<label  for="monUid" title="${monuidTooltip}" onclick="updateHelpPortlet(event);">
									<fmt:message key="SECURITY.MONITORUSERNAME.LABEL"/>
							
								<br>
												
								<input id="monUid" type="text" name="monUid" class="textEntry" title="${monuidTooltip}" ${security eq 'no' ? 'disabled="disabled"' : ''}>
								
							</label>
						</td>	
						<td class="table-text"  scope="row" valign="top">
							<label  for="monPwd" title="${monuidTooltip}" onclick="updateHelpPortlet(event);">
									<fmt:message key="SECURITY.MONITORUSERPWD.LABEL"/>
							
							<br>	
									<input id="monPwd" type="password" name="monPwd" class="textEntry" title="${monuidTooltip}" ${security eq 'no' ? 'disabled="disabled"' : ''}>
							</label>	
						</td>	
					</tr>
				</table>
			</td>
		</tr>
	</table>
	</fieldset>
	<fieldset><legend><fmt:message key="FIELDSET.LEGEND"/></legend>
	<table cellpadding="3">
		<tr>
			<td><label for="targetServer" class="hasHelp" onclick="updateHelpPortlet(event);" title="<fmt:message key='FIELD.TARGET.TOOLTIP'/>"><fmt:message key="FIELD.TARGET.LABEL"/></label></td>
		</tr>
		<tr>
			<td><select name="targetServer" title="<fmt:message key='FIELD.TARGET.TOOLTIP'/>">
			    	<option value=""><fmt:message key="FIELD.TARGET.OPTION.NONE"/></option>
				    <c:forEach var="server" items="${servers}">
				    	<option value="${server.key}">${server.value}*</option>
					</c:forEach>
					<c:forEach var="server" items="${serversNotAvailable}">
				    	<option value="${server.key}" disabled="disabled">${server.value}</option>				    	
					</c:forEach>
			    </select>
			</td>
		</tr>
		<tr>
			<td><input id="launch-topology-wizard-button" class="nav-button" type="submit" value="<fmt:message key='BUTTON.LABEL'/>" title="<fmt:message key='BUTTON.TOOLTIP'/>" name="launch-topology-wizard-button-name"></td>
		</tr>
	</table>
	</fieldset>
</form>
</c:if>
</div>
</div>

<div class="sideContent">
	
	<div class="sectionContent">
	<p class="config-section-title"><fmt:message key="LINK.SECTION.APPLICATIONS"/></p>
	<ul style="padding-left: 10px">
		<li><a class="nav-link" href="/ibm/console/navigatorCmd.do?forwardName=ApplicationDeployment.content.main&WSC=true"><fmt:message key="LINK.APPLICATIONS"/></a></li>
	</ul>
	</div>
	
</div>

</div>
</fmt:bundle>