<%--
  Licensed Materials - Property of IBM
  5724-M24
  Copyright IBM Corporation 2007,2010. All Rights Reserved.
  US Government Users Restricted Rights - Use, duplication or disclosure
  restricted by GSA ADP Schedule Contract with IBM Corp.
--%> 
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@page session="true" contentType="text/html" pageEncoding="ISO-8859-1" import="java.util.*,javax.portlet.*,com.ibm.wbimonitor.security.rest.admin.*" %>

<%@taglib uri="http://java.sun.com/portlet" prefix="portlet" %>
<portlet:defineObjects/>

<%@ include file="includeDojoIfNecessary.jspf" %>


<html lang="en">
<head>

<script language="JavaScript" type="text/javascript">
  dojo.require("dojo.rpc.JsonService");
  dojo.require("dojo.string");

  dojo.addOnLoad(init);

  var restAdmin = new dojo.rpc.JsonService("/AdminUI/RPCAdapter/jsonrpc/RESTSecurityAdminImpl");

  var messages = null;
  var savedJSESSIONID = null;

  function queryResourceGroupStatus()
  {
     restAdmin.getAllResourceGroupsWithMemberCount().addCallback(queryResourceGroupsCallback);
  }

  var rootRGEmpty = true;
  var childRGEmpty = false;
  var allChildrenEmpty = true;
  var childrenExist = false;
  var mdsCheckPerformed = false;
  function queryResourceGroupsCallback(data)
  {
     document.cookie='JSESSIONID=' + savedJSESSIONID + ';path=/ibm';

     if (data)
        resourceGroups = data;

     var mdsText   = document.getElementById('mdsText');

     while (mdsText.firstChild)
        mdsText.removeChild(mdsText.firstChild);

     if (resourceGroups.length > 1) {
        childrenExist = true;
     }

     //Set the text
     for (var i=0; i < resourceGroups.length; i++) {
        var rgInfo = resourceGroups[i];

        var text = null;
        if (rgInfo[1] > 1) {
           text = dojo.string.substitute(messages.membersInRG, [rgInfo[1], rgInfo[0]]);
        } else if (rgInfo[1] == 0) {
           text = dojo.string.substitute(messages.noMembersInRG, [rgInfo[0]]);
        } else {
           text = dojo.string.substitute(messages.oneMemberInRG, [rgInfo[0]]);
        }

        mdsText.appendChild(document.createTextNode(text));

        if (i < resourceGroups.length) {
           br2 = document.createElement('br');
           mdsText.appendChild(br2);
        }

        //Check to see if the root RG is empty
        if (rgInfo[0] == 'root') {
           if (rgInfo[1] > 0) {
              rootRGEmpty = false;
           }
        }

        if (rgInfo[0] != 'root') {
           //Check to see if any of the children are empty
           if (rgInfo[1] > 0) {
              allChildrenEmpty = false;
           }

           //Check to see if all the children are empty
           if (rgInfo[1] == 0) {
              childRGEmpty = true;
           }
        }
     }
     mdsCheckPerformed = true;
     setMDSStatusIcon();
  }

  function queryUsers()
  {
     restAdmin.getAllUsersLimit("*", "10").addCallback(queryAllUsersCallback);
  }

  var userSearchPerformed = false;
  var userSearchSuccess   = false;

  function queryAllUsersCallback(data)
  {
     document.cookie='JSESSIONID=' + savedJSESSIONID + ';path=/ibm';

     var regSearchable = document.getElementById('registrySearchable');
     while (regSearchable.firstChild)
        regSearchable.removeChild(regSearchable.firstChild);

     var cellText = null;

     var exceptionReturned = false;
     var exceptionText = null;
     if (data) {
        if (data.length == 2) {
           if (data[0] == 'exception') {
              exceptionReturned = true;
              exceptionText = data[1];
           }
           if (data[1] == 'exception') {
              exceptionReturned = true;
              exceptionText = data[0];
           }
        }

        if (exceptionReturned == true) {
           var anchor = document.createElement('a');
           anchor.appendChild(document.createTextNode(messages.registryException));
           anchor.href = 'javascript:alert("' + exceptionText + '")';
           regSearchable.appendChild(anchor);
        } else {
           if (data.length == 0) {
              cellText = messages.registryNotSearchable;
           } else {
              cellText = messages.registrySearchable;
              if (exceptionReturned == false) {
                 userSearchSuccess = true;
              }
           }
           regSearchable.appendChild(document.createTextNode(cellText));
        }

        userSearchPerformed = true;
        setSecurityStatusIcon();
     }
  }

  function getGlobalSecurityConfiguration() {
     restAdmin.getGlobalSecurityConfiguration().addCallback(getGlobalSecurityConfigurationCallback);
  }

  var adminSecEnabled = false;
  var securityEnabled = false;
  var registryFound = false;
  var registrySearchable = false;
  var securityStatusPerformed = false;
  var vmmEnabled = false;
  function getGlobalSecurityConfigurationCallback(data)
  {
     document.cookie='JSESSIONID=' + savedJSESSIONID + ';path=/ibm';

     var globalsec = data[0];
     var appsec = data[1];
     var registry  = data[2];
     
     if (globalsec[0] == "GlobalSecurity") {
        var adminSecDiv = getElement('adminSecStatus');
        if (globalsec[1] == "true") {
           adminSecEnabled = true;
           setText(adminSecDiv, messages.adminSecEnabled);
        } else {
           setText(adminSecDiv, messages.adminSecDisabled);
        }
     }

     if (appsec[0] == "ServerSecurity") {
        var appSecDiv = getElement('appSecStatus');
        if (appsec[1] == "true") {
           setText(appSecDiv, messages.appSecEnabled);
           securityEnabled = true;
        } else {
           setText(appSecDiv, messages.appSecDisabled);
        }
     }

     if (registry[0] == "SelectedRegistry") {
        var adminSecDiv = getElement('registrySelected');
        if (registry[1] == "LocalOSUserRegistry") {
           registryFound = true;
           setText(adminSecDiv, messages.repositoryLocalOS);
        } else if (registry[1] == "CustomUserRegistry") {
           registryFound = true;
           setText(adminSecDiv, messages.repositoryCUR);
        } else if (registry[1] == "LDAPUserRegistry") {
           registryFound = true;
           setText(adminSecDiv, messages.repositoryLDAP);
        } else if (registry[1] == "WIMUserRegistry") {
           vmmEnabled = true;
           registryFound = true;
           setText(adminSecDiv, messages.repositoryVMM);
        } else {
           setText(adminSecDiv, messages.repositoryUnknown);
        }
     }
     
     var regSearchableElement = document.getElementById('registrySearchable');
     while (regSearchableElement.firstChild)
        regSearchableElement.removeChild(regSearchableElement.firstChild);

     if (registryFound == true) {
        if (vmmEnabled == true) {
           if (adminSecEnabled == false) {
              regSearchableElement.appendChild(document.createTextNode(messages.registryNoAdminSec));
           } else {
              registrySearchable = true
              queryUsers();
           }
        } else {
           if (securityEnabled == false) {
              regSearchableElement.appendChild(document.createTextNode(messages.registryNoAppSec));
           } else {
              registrySearchable = true
              queryUsers();
           }
        }
     }
     
     securityStatusPerformed = true;
     setSecurityStatusIcon();
     setMDSStatusIcon();
  }

  function setSecurityStatusIcon() {

     if (securityStatusPerformed == true) {

        //Set the status icon
        var secStatus = document.getElementById('secStatus');

        if (registryFound == false) {
           secStatus.src="/SecurityInfo/images/error.gif";
           secStatus.title = messages.secStatusNoRegFound;
        }

        if ((registrySearchable == true) && (userSearchPerformed == true)) {
   
           if (userSearchSuccess == true) {
              secStatus.src="/SecurityInfo/images/check.gif";
              secStatus.title = messages.secStatusOK;
           } else {
              secStatus.src="/SecurityInfo/images/error.gif";
              secStatus.title = messages.secStatusNoUsersInReg;
           }
        } else {
           secStatus.src="/SecurityInfo/images/notfound.gif";
           if ((vmmEnabled == true) && (adminSecEnabled == false)) {
              secStatus.title = messages.secStatusNoAdminSec;
           } else {
              secStatus.title = messages.secStatusNoAppSec;
           }
        }
     }
  }

  function setMDSStatusIcon() {

     if ((securityStatusPerformed == true) && (mdsCheckPerformed == true)) {
        //Set the status icon
        var mdsStatus = document.getElementById('mdsStatus');

        if (securityEnabled == true) {
           if (childrenExist == true) {
   
              if (childRGEmpty == false) {
                 mdsStatus.src="/SecurityInfo/images/check.gif";
                 mdsStatus.title = messages.mdsStatusOK;
              } else if ((childRGEmpty == true) && (rootRGEmpty == false)) {
                 mdsStatus.src="/SecurityInfo/images/warning.gif";
                 mdsStatus.title = messages.mdsStatusWarnChildEmpty;
              } else {
                 mdsStatus.src="/SecurityInfo/images/error.gif";
                 mdsStatus.title = messages.mdsStatusErrorChildEmpty;
              }
   
           } else {
   
              if (rootRGEmpty) {
                 mdsStatus.src="/SecurityInfo/images/error.gif";
                 mdsStatus.title = messages.mdsStatusErrorRootEmpty;
              } else {
                 mdsStatus.src="/SecurityInfo/images/check.gif";
                 mdsStatus.title = messages.mdsStatusOK;
              }
           }
        } else {
           mdsStatus.src="/SecurityInfo/images/notfound.gif";
           mdsStatus.title = messages.mdsStatusNoAppSec;
        }
     }
  }

  function getSSOConfiguration() {
     restAdmin.getSSOConfiguration().addCallback(getSSOConfigurationCallback);
  }

  function getSSOConfigurationCallback(data)
  {
     document.cookie='JSESSIONID=' + savedJSESSIONID + ';path=/ibm';

     var ssoEnabledElement = getElement("ssoEnabled");
     var ssoDomainElement  = getElement("ssoDomain");

     if (data) {

        var ssoEnabled = false;
        var ssoDomain  = null;
        var contextId = null;
        var resourceUri = null;
        var parentRefId = null;

        for (var c=0; c< data.length; c++) {
           var nvp = data[c];
           if (nvp[0] == "SSOEnabled") {
              if (nvp[1] == "true") {
                 ssoEnabled = true;
              }
           } else if (nvp[0] == "SSODomain") {
              ssoDomain =  nvp[1];
           } else if (nvp[0] == "contextId") {
              contextId =  nvp[1];
           } else if (nvp[0] == "resourceUri") {
              resourceUri =  nvp[1];
           } else if (nvp[0] == "parentRefId") {
              parentRefId =  nvp[1];
           }
        }

        if ((contextId != null) && (resourceUri != null) && (parentRefId != null)) {

           contextId = escape(contextId);

           var ssoURL = "/ibm/console/com.ibm.ws.console.security.forwardCmd.do?forwardName=SingleSignon.config.view&sfname=singleSignon&resourceUri=" + resourceUri + "&parentRefId=" + parentRefId + "&contextId=" + contextId + "&perspective=tab.configuration";

           var td = document.getElementById('titleSSO');
           while (td.firstChild)
              td.removeChild(td.firstChild);

           var a = document.createElement('a');
           a.href = ssoURL;
           a.appendChild(document.createTextNode(messages.titleSSO));
           td.appendChild(a);
        }
        
        if ((ssoEnabled) && (ssoEnabled = true)) {
           setText(ssoEnabledElement, messages.ssoEnabled);
           if (ssoDomain == "") {
              setText(ssoDomainElement, messages.ssoDomainNotSpecified);
           } else {
              text = dojo.string.substitute(messages.ssoDomain, [ssoDomain]);
              setText(ssoDomainElement, text);
           }
        } else {
           setText(ssoEnabledElement, messages.ssoDisabled);
        }
     }
  }

  function getLTPAConfiguration() {
     restAdmin.getLTPAConfiguration().addCallback(getLTPAConfigurationCallback);
  }

  function getLTPAConfigurationCallback(data)
  {
     document.cookie='JSESSIONID=' + savedJSESSIONID + ';path=/ibm';

     var ltpaRegenEnabledElement = getElement("ltpaRegenEnabled");
     var ltpaRegenDateElement  = getElement("ltpaRegenDate");

     if (data) {

        var ltpaRegenEnabled = false;
        var ltpaRegenDate  = null;
        var contextId = null;
        var resourceUri = null;
        var parentRefId = null;

        for (var c=0; c< data.length; c++) {
           var nvp = data[c];
           if (nvp[0] == "LTPARegen") {
              if (nvp[1] == "true") {
                 ltpaRegenEnabled = true;
              }
           } else if (nvp[0] == "LTPARegenDate") {
              ltpaRegenDate =  nvp[1];
           } else if (nvp[0] == "contextId") {
              contextId =  nvp[1];
           } else if (nvp[0] == "resourceUri") {
              resourceUri =  nvp[1];
           } else if (nvp[0] == "parentRefId") {
              parentRefId =  nvp[1];
           }
        }

        if ((contextId != null) && (resourceUri != null) && (parentRefId != null)) {

           contextId = escape(contextId);

           var ltpaURL = "/ibm/console/com.ibm.ws.console.security.forwardCmd.do?forwardName=AuthMechanism.config.view&sfname=authMechanisms&resourceUri=" + resourceUri + "&parentRefId=" + parentRefId + "&contextId=" + contextId + "&perspective=tab.configuration";

           var td = document.getElementById('titleLTPA');
           while (td.firstChild)
              td.removeChild(td.firstChild);

           var a = document.createElement('a');
           a.href = ltpaURL;
           a.appendChild(document.createTextNode(messages.titleLTPA));
           td.appendChild(a);
        }
        
        if ((ltpaRegenEnabled) && (ltpaRegenEnabled = true)) {
           setText(ltpaRegenEnabledElement, messages.ltpaRegenEnabled);
           text = dojo.string.substitute(messages.ltpaRegenDate, [ltpaRegenDate]);
           setText(ltpaRegenDateElement, text);
        } else {
           setText(ltpaRegenEnabledElement, messages.ltpaRegenDisabled);
        }
     }
  }

  function trim(str)
  {
     return str.replace(/^\s*/, "").replace(/\s*$/, "");
  }

  function getCookie(name)
  {
     var val = null;
     if (document.cookie) {
        var cookies = document.cookie.split(';');
        for (var i=0; (i<cookies.length) && !val; i++) {
           var j = cookies[i].indexOf('=');
           if (j > 0) {
              if (trim(cookies[i].substring(0,j)) == name) {
                 val = cookies[i].substring(j+1);
              }
           }
        }
     }
     return val;
  }

  function getElement(elementID) {
     foundElement = document.getElementById(elementID);

     while (foundElement.firstChild)
        foundElement.removeChild(foundElement.firstChild);

     return foundElement;
  }

  function setText(elementID, text) {
     elementID.appendChild(document.createTextNode(text));
  }


  function init()
  {
     //IMPORTANT: Each json-rpc servlet response contains a new JSESSIONID , effectively logging out 
     //           the current user - the original JSESSIONID cookie must be restored on each callback 
     savedJSESSIONID = getCookie('JSESSIONID');    //save cookie 

     var locale = "<%=request.getLocale().toString().toLowerCase().replace('_','-')%>";
     dojo.requireLocalization("SecurityUI","securityInfoResource", locale);
     messages = dojo.i18n.getLocalization("SecurityUI","securityInfoResource", locale);

     document.getElementById("adminTitle").appendChild(document.createTextNode(messages.adminTitle));
     document.getElementById("adminInstruction").appendChild(document.createTextNode(messages.adminInstruction));

     document.getElementById("titleGlobalSecurity").appendChild(document.createTextNode(messages.titleGlobalSecurity));
     document.getElementById("titleMDS").appendChild(document.createTextNode(messages.titleMDS));
     document.getElementById("thComponent").appendChild(document.createTextNode(messages.titleComponent));
     document.getElementById("thStatus").appendChild(document.createTextNode(messages.titleStatus));

     //Fill in the Global Security status 
     getGlobalSecurityConfiguration();

     //Fill in the Monitor Data Security Status 
     queryResourceGroupStatus();

     //Fill in the LTPA Status 
     getLTPAConfiguration();

     //Fill in the SSO Status 
     getSSOConfiguration();
  }
  
</script>

</head>
<%@ include file="was-styles-common.jsp" %>
<body>

<div>
  <table height="100%" cellspacing="0" cellpadding="0" border="0" width="100%" dir="ltr">
    <tbody>
    <tr>
      <td height="100%" width="100%" valign="top" colspan="3">
        <div class="monitor">
          <h1>
          <p class="title-bread-crumb" id="adminTitle">
          </p>
          </h1>
          <p id="adminInstruction">
          </p>
          <div class="mainContent" style="width: auto;">
            <div class="sectionContent">
              <table class="framing-table" cellspacing="1" cellpadding="3" width="100%">
                <thead>
                <tr>
                  <th class="column-head-name"><img height="16" border="0" width="16" alt="" src="/SecurityInfo/images/onepix.gif"/></th>
                  <th id="thComponent" class="column-head-name" nowrap="" align="left"></th>
                  <th id="thStatus"    class="column-head-name" nowrap="" align="left"></th>
                </tr>
                </thead>
                <tbody>
                <tr class="table-row" id="secinfoGlobalSec">
                  <td align="center" valign="top"><img id="secStatus" height="16" border="0" width="16" alt="" src="/SecurityInfo/images/onepix.gif"/></td>
                  <td valign="top"><a id="titleGlobalSecurity" style="text-decoration: underline;" href="/ibm/console/navigatorCmd.do?forwardName=AdminSecurity.config.view&WSC=true"></a></td>
                  <td>
                    <div id="adminSecStatus">
                    </div>
                    <div id="appSecStatus">
                    </div>
                    <div id="registrySelected">
                    </div>
                    <div id="registrySearchable">
                    </div>
                  </td>
                </tr>
                <tr class="table-row" id="secinfoMDS">
                  <td align="center" valign="top"><img id="mdsStatus" height="16" border="0" width="16" alt="" src="/SecurityInfo/images/onepix.gif"/></td>
                  <td valign="top"><a id="titleMDS" style="text-decoration: underline;" href="/ibm/console/navigation.do?pageID=node.8b1b4fb931&moduleRef=com.ibm.wbimonitor.security.rest.admin.AdminUIPortlet&ISC.TASKTYPE=2"></a></td>
                  <td id="mdsText" valign="top"></td>
                </tr>
                <tr class="table-row" id="secinfoLTPA">
                  <td align="center" valign="top"><img height="16" border="0" width="16" alt="" src="/SecurityInfo/images/onepix.gif"/></td>
                  <td valign="top" id="titleLTPA"></td>
                  <td>
                    <div id="ltpaRegenEnabled">
                    </div>
                    <div id="ltpaRegenDate">
                    </div>
                  </td>
                </tr>
                <tr class="table-row" id="secinfoSSO">
                  <td align="center" valign="top"><img height="16" border="0" width="16" alt="" src="/SecurityInfo/images/onepix.gif"/></td>
                  <td valign="top" id="titleSSO" ></td>
                  <td>
                    <div id="ssoEnabled">
                    </div>
                    <div id="ssoDomain">
                    </div>
                  </td>
                </tr>
              </table>
            </div>
          </div>
        </div>
      </td>
    </tr>
    </tbody>
  </table>
</div>


</body>
</html>