######################################################################
#
#  Licensed Materials - Property of IBM
#  5724-M24
#  Copyright IBM Corporation 2011. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
#  
######################################################################

import sys, os, shutil
from os import environ

#--------------------------------------------------------------------------
# get the directory where WAS: installed
#--------------------------------------------------------------------------
def getWASHome():
	return getPropertyValue('was.install.root')
#--------------------------------------------------------------------------
# get the profile root
#--------------------------------------------------------------------------	
def getUserInstallRoot():
	return getPropertyValue('user.install.root')
#------------------------------------------------------------------------------
# get the property value by the the property name; If property not available, return ''
#------------------------------------------------------------------------------
def getPropertyValue(propertyName):
	propertyValue = java.lang.System.getProperty(propertyName)
	if(propertyValue == None):
		return ''
	return propertyValue

#main 
print "\n\nProfile upgrade to latest WBM version started for",System.getProperty("user.install.root")
#props = System.getProperties()
#for pname in props.keys():
#  print('%s=%s' % (pname, System.getProperty(pname)))
ext = "sh"
if (System.getProperty("os.name").startswith("Windows")):
	ext = "bat"
wasRoot = getWASHome()
profileRoot    = getUserInstallRoot()
src = wasRoot + "/firststeps.wbm/ivt/ivt."+ext
dst = profileRoot + "/firststeps.wbm/ivt/ivt."+ext

print "    ********************************************************"
print "    ********************************************************"
print "    WAS home directory:             ",wasRoot
print "    Profile home directory:         ",profileRoot


profileType = getPropertyValue('bpm.upgrade.profile.type')
print "    BPM Profile type:               ",profileType

if (profileType.find('wbmonitor') >= 0):
	print "\n    This is a WBM profile to upgrade"
	# lets do the copy
	print "    upgrading profile file:         ",dst
	shutil.copy(src,dst)
	print "  "
	print "\nProfile upgrade to latest WBM version ended for",profileRoot
	print "    ********************************************************"
	print "    ********************************************************"	
else:
	print "\n    This is not a WBM profile to upgrade"
	print "    ********************************************************"
	print "    ********************************************************"	
print "UPGRADE ended for " + profileRoot + "\n"